/*
 *  GOL - Game of life simulation software
 *  Copyright (C) 1996 Michael Raymond Brown
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Author: Michael Raymond Brown
 *  EMail:  michael@arrakeen.demon.co.uk
 *  WWW:    http://www.arrakeen.demon.co.uk/
 *  Address:  Michael Brown
 *            Kia Ora
 *            Brook Street
 *            Great Bromley
 *            Nr Colchester
 *            Essex
 *            CO7 7HX
 *            England
 */


#ifdef __GNUC__
#pragma implementation
#endif

#include "Text.h"
#include <string.h>

xwText::xwText(xwWidget* p, int w, int h, int x1, int y1, int x2, int y2)
   {
    parent = p;
    widget = XtVaCreateManagedWidget("button"
		, xmTextWidgetClass, parent->getWidget()

		, XmNleftAttachment,	XmATTACH_POSITION
		, XmNrightAttachment,	XmATTACH_POSITION
		, XmNtopAttachment,	XmATTACH_POSITION
		, XmNbottomAttachment,	XmATTACH_POSITION

		, XmNleftPosition,	x1
		, XmNrightPosition,	x2
		, XmNtopPosition,	y1
		, XmNbottomPosition,	y2

		, XmNcolumns, (short)w
		, XmNrows, (short)h

		, XmNeditMode,	h>1 ? XmMULTI_LINE_EDIT : XmSINGLE_LINE_EDIT

		, 0);

    default_callbacks(evnt_Change, meth_Size|meth_Close);
    linkParent(p);
   }
xwText::xwText(xwWidget* p, int w, int h)
   {
    parent = p;
    widget = XtVaCreateManagedWidget("button"
		, xmTextWidgetClass, parent->getWidget()
		, XmNcolumns, (short)w
		, XmNrows, (short)h
		, XmNeditMode,	h>1 ? XmMULTI_LINE_EDIT : XmSINGLE_LINE_EDIT
		, 0);

    default_callbacks(evnt_Change, meth_Size|meth_Close);
    linkParent(p);
   }
xwText::xwText(xwWidget* p)
   {
    parent = p;
    widget = XtVaCreateManagedWidget("button"
		, xmTextWidgetClass, parent->getWidget()
		, 0);

    default_callbacks(evnt_Change, meth_Size|meth_Close);
    linkParent(p);
   }
xwText::~xwText()
   {
   }


void xwText::setText(const char* text)
   {XmTextSetString(widget, (char*)text);
   }
char* xwText::getText()
   {char* ptr1 = XmTextGetString(widget);
    char* ptr2 = new char[strlen(ptr1)+1];
    strcpy(ptr2, ptr1);
    XtFree(ptr1);
    return ptr2;
   }

void xwText::setEditable(int v)
   {XtVaSetValues(widget, XmNeditable, (Boolean)v, 0);
   }
int xwText::getEditable()
   {Boolean v;
    XtVaGetValues(widget, XmNeditable, &v, 0);
    return (int)v;
   }




